unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids,  Spin;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    SpinEdit1: TSpinEdit;
    Button2: TButton;
    StringGrid2: TStringGrid;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    SpinEdit2: TSpinEdit;
    Label7: TLabel;
    Edit4: TEdit;
    Label8: TLabel;
    SpinEdit3: TSpinEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit5: TEdit;
    Label12: TLabel;
    Edit6: TEdit;
    Label13: TLabel;
    Edit7: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    StringGrid3: TStringGrid;
    Button3: TButton;
    Button4: TButton;
    SpinEdit4: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  pop : array of integer;
  pcnt : array of double;
  species : array[0..2] of integer;
  dirinfo,dirinfo0 : string;
  txt : TextFile;
  strbuf : string;
  FileDum : string;

implementation

uses Unit2, Unit3;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
ii,jj : integer;
nelectron,i_mem, j_mem : integer;
count : integer;
label 10,20;
begin
  if StrToFloat(Edit3.Text) > StrToFloat(Edit4.Text) then
    begin
      ShowMessage('The number of radical should be less than the total number of MV2+; TN_Rad must be less than TN_MV');
      goto 20;
    end;

  SetLength(pop,SpinEdit2.Value*SpinEdit3.Value+2);
  SetLength(pcnt,SpinEdit2.Value*SpinEdit3.Value+2);

  Form1.StringGrid1.RowCount := Form1.SpinEdit1.Value+1;
  Form1.StringGrid1.ColCount := Form1.SpinEdit2.Value*Form1.SpinEdit3.Value+1;

  for ii := 1 to Form1.StringGrid1.RowCount -1 do
    begin
      Form1.StringGrid1.Cells[0,ii] := IntToStr(ii);
      for jj := 1 to Form1.SpinEdit2.Value*Form1.SpinEdit3.Value do
        begin
          Form1.StringGrid1.Cells[jj,ii] := '';
        end;
    end;

  Form1.Edit5.Text := IntToStr(round(Form1.SpinEdit1.Value*StrToFloat(Edit3.Text)));

  nelectron := 0;
  repeat

    10:
    j_mem := random(Form1.SpinEdit2.Value*Form1.SpinEdit3.Value+1);
    i_mem := random(Form1.SpinEdit1.Value+1);

    if j_mem = 0 then goto 10;
    if i_mem = 0 then goto 10;
    if Form1.StringGrid1.Cells[j_mem,i_mem] = '1' then goto 10;

    Form1.StringGrid1.Cells[j_mem,i_mem] := '1';
    nelectron := nelectron + 1;

  until nelectron = round(Form1.SpinEdit1.Value*StrToFloat(Edit3.Text));

  count := 0;
  for ii := 1 to Form1.StringGrid1.RowCount -1 do
    begin
      for jj := 1 to Form1.SpinEdit2.Value*Form1.SpinEdit3.Value do
        begin
          if Form1.StringGrid1.Cells[jj,ii] <> '1' then  Form1.StringGrid1.Cells[jj,ii] := '0';
          if Form1.StringGrid1.Cells[jj,ii] = '1' then count := count + 1;
        end;
    end;

  Form1.Edit6.Text := IntToStr(count);
  Form1.Edit7.Text := FloatToStr(count/Form1.SpinEdit1.Value);

20:

end;

procedure TForm1.Button2Click(Sender: TObject);
var
ii,jj,kk : integer;
{mv4d0,mv3d1,mv2d2,mv1d3,mv0d4: integer;   }
kazu : integer;
{r0,r1,r2,r3,r4 : double;   }
{n0,n1,n2 : double;         }
{check : integer;           }
{fugo : integer;            }
sowa : integer;
sowa2 : double;
sum : double;

{tn_spec : integer;         }



begin

  Form1.StringGrid2.RowCount := Form1.SpinEdit2.Value*Form1.SpinEdit3.Value + 4;
  Form1.StringGrid2.Cells[0,0] := 'chemical species';
  Form1.StringGrid2.Cells[1,0] := 'counts (#)';
  Form1.StringGrid2.Cells[2,0] := 'abndnc (%)';
  for ii := 1 to Form1.StringGrid2.RowCount -1 do
    begin
       Form1.StringGrid2.Cells[0,ii] := '';
       Form1.StringGrid2.Cells[1,ii] := '';
       Form1.StringGrid2.Cells[2,ii] := '';
    end;
  for ii := 0 to Form1.SpinEdit2.Value*Form1.SpinEdit3.Value do
    begin
      Form1.StringGrid2.Cells[0,ii+1] := 'PtCl2bpy-(MV2+)'+IntToStr(Form1.SpinEdit2.Value*Form1.SpinEdit3.Value-ii)+'(MV+d)'+IntToStr(ii);
    end;

  for ii := 0 to Form1.SpinEdit2.Value*Form1.SpinEdit3.Value do
    begin
      pop[ii] := 0;
    end;
 { check := 0;  }

  for ii := 1 to Form1.StringGrid1.RowCount -1 do
    begin
      kazu := 0;
      for jj := 1 to Form1.SpinEdit2.Value*Form1.SpinEdit3.Value do
        begin
          kazu := kazu + StrToInt(Form1.StringGrid1.Cells[jj,ii]);
        end;
      pop[kazu] := pop[kazu] + 1;
    end;

  sowa := 0;
  for ii :=  0 to Form1.SpinEdit2.Value*Form1.SpinEdit3.Value do
    begin
      sowa := sowa + pop[ii];
    end;

  for ii :=  0 to Form1.SpinEdit2.Value*Form1.SpinEdit3.Value do
    begin
      Form1.StringGrid2.Cells[1,ii+1] := IntToStr(pop[ii]);
      Form1.StringGrid2.Cells[2,ii+1] := FloatToStr(100*pop[ii]/sowa);
      pcnt[ii] := 100*pop[ii]/sowa;
    end;

  sowa2 := 0;
  for ii := 0 to Form1.SpinEdit2.Value*Form1.SpinEdit3.Value do
    begin
      sowa2 := sowa2 + StrToFloat(Form1.StringGrid2.Cells[2,ii+1]);
    end;
  Form1.StringGrid2.Cells[0,Form1.SpinEdit2.Value*Form1.SpinEdit3.Value+3] := 'sum';
  Form1.StringGrid2.Cells[1,Form1.SpinEdit2.Value*Form1.SpinEdit3.Value+3] := IntToStr(sowa);
  Form1.StringGrid2.Cells[2,Form1.SpinEdit2.Value*Form1.SpinEdit3.Value+3] := FloatToStr(sowa2);


  for ii := 0 to 2 do
    begin
      species[ii] := 0;
    end;
{  tn_spec := Form1.SpinEdit1.Value*Form1.SpinEdit2.Value*Form1.SpinEdit3.Value;     }

  for kk := 1 to Form1.SpinEdit3.Value do
    begin
      for ii := 1 to Form1.SpinEdit1.Value do
        begin
          kazu := 0;
          for jj := 1+Form1.SpinEdit2.Value*(kk-1) to Form1.SpinEdit2.Value+Form1.SpinEdit2.Value*(kk-1) do
            begin
              kazu := kazu + StrToInt(Form1.StringGrid1.Cells[jj,ii]);
            end;

          species[0] := species[0] + Form1.SpinEdit2.Value - kazu;
          species[1] := species[1] + kazu mod 2;
          species[2] := species[2] + (kazu div 2)*2;

        end;
    end;

  Form1.StringGrid3.Cells[0,0] := 'species';
  Form1.StringGrid3.Cells[1,0] := 'counts (#)';
  Form1.StringGrid3.Cells[2,0] := 'abndnc (%)';
  for ii := 1 to Form1.StringGrid3.RowCount -1 do
    begin
       Form1.StringGrid3.Cells[0,ii] := '';
       Form1.StringGrid3.Cells[1,ii] := '';
       Form1.StringGrid3.Cells[2,ii] := '';
    end;
  Form1.StringGrid3.Cells[0,1] := 'Non-reduced MV2+';
  Form1.StringGrid3.Cells[0,2] := 'Monoradical MV+d';
  Form1.StringGrid3.Cells[0,3] := 'Diradical (MV+d)2 / 2';

  sum := 0;
  for ii := 0 to 2 do
    begin
      sum := sum + species[ii];
    end;

  for ii := 0 to 2 do
    begin
      Form1.StringGrid3.Cells[1,ii+1] := IntToStr(species[ii]);
      Form1.StringGrid3.Cells[2,ii+1] := copy(FloatToStr(100*species[ii]/sum),1,8);
    end;

  sowa := 0;
  sowa2 := 0;
  for ii := 1 to 3 do
    begin
      sowa := sowa + StrToInt(Form1.StringGrid3.Cells[1,ii]);
      sowa2 := sowa2 + StrToFloat(Form1.StringGrid3.Cells[2,ii]);
    end;

  Form1.StringGrid3.Cells[0,5] := 'sum';
  Form1.StringGrid3.Cells[1,5] := IntToStr(sowa);
  Form1.StringGrid3.Cells[2,5] := FloatToStr(sowa2);

end;


procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  Form1.Edit4.Text := IntToStr(Form1.SpinEdit2.Value*Form1.SpinEdit3.Value);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  ii,jj : integer;
begin
  Form3.StringGrid1.RowCount := Form1.SpinEdit2.Value*Form1.SpinEdit3.Value+5;
  Form3.StringGrid2.RowCount := Form1.SpinEdit2.Value*Form1.SpinEdit3.Value+5;
  Form3.StringGrid1.ColCount := Form1.SpinEdit4.Value+1;

  Form1.Button1Click(Sender);
  Form1.Button2Click(Sender);

  for ii := 1 to Form1.StringGrid2.RowCount-3 do
    begin
      Form3.StringGrid1.Cells[0,ii] := Form1.StringGrid2.Cells[0,ii];
    end;

  for ii := Form1.StringGrid2.RowCount-2 to Form1.StringGrid2.RowCount do
    begin
      Form3.StringGrid1.Cells[0,ii] := Form1.StringGrid3.Cells[0,ii-Form1.StringGrid2.RowCount+3];
    end;

  for jj := 1 to Form1.SpinEdit4.Value do
    begin
      if jj > 1 then
        begin
          Button1Click(Sender);
          Button2Click(Sender);
        end;

      for ii := 1 to Form1.StringGrid2.RowCount-3 do
        begin
          Form3.StringGrid1.Cells[jj,ii] := Form1.StringGrid2.Cells[2,ii];
        end;

      for ii := Form1.StringGrid2.RowCount-2 to Form1.StringGrid2.RowCount do
        begin
          Form3.StringGrid1.Cells[jj,ii] := Form1.StringGrid3.Cells[2,ii-Form1.StringGrid2.RowCount+3];
        end;
      Form3.StringGrid1.Cells[jj,0] := 'Run #'+IntToStr(jj);
    end;

  Form3.Button1Click(Sender);
  Form3.Show;
  
end;

initialization
  GetDir(0,dirinfo0);

   if FileExists(dirinfo0+'\dirinfo') then
     begin
       AssignFile(txt,dirinfo0+'\dirinfo');
       Reset(txt);
       Readln(txt,dirinfo);
       dirinfo := Trim(dirinfo);
       CloseFile(txt);
       SetCurrentDir(dirinfo);
     end;

end.
