unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Grids, StdCtrls;

type
  TForm3 = class(TForm)
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    SaveDialog1: TSaveDialog;
    Save1: TMenuItem;
    StringGrid2: TStringGrid;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form3: TForm3;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm3.Button1Click(Sender: TObject);
var
  ii,jj : integer;
  sum, mean, sigma : double;
begin
  for jj := 1 to Form3.StringGrid1.RowCount -1 do
    begin
      Form3.StringGrid2.Cells[0,jj] := Form3.StringGrid1.Cells[0,jj];
    end;

  Form3.StringGrid2.Cells[1,0] := 'Mean';
  Form3.StringGrid2.Cells[2,0] := 'Sigma';


  for jj := 1 to Form3.StringGrid1.RowCount -1 do
    begin
      sum := 0;
      for ii := 1 to Form3.StringGrid1.ColCount-1 do
        begin
          sum := sum + StrToFloat(Form3.StringGrid1.Cells[ii,jj]);
        end;
      mean := sum/(Form3.StringGrid1.ColCount -1);

      sum := 0;
      for ii := 1 to Form3.StringGrid1.ColCount-1 do
        begin
          sum := sum + (mean-StrToFloat(Form3.StringGrid1.Cells[ii,jj]))*(mean-StrToFloat(Form3.StringGrid1.Cells[ii,jj]));
        end;
      sigma := sqrt(sum/(Form3.StringGrid1.RowCount -2));

      Form3.StringGrid2.Cells[1,jj] := copy(FloatToStr(mean),1,8);
      Form3.StringGrid2.Cells[2,jj] := copy(FloatToStr(sigma),1,8);
    end;

end;

procedure TForm3.Save1Click(Sender: TObject);
var
  ii,jj : integer;
  SaveFile : string;
begin
  With SaveDialog1 do
  if Execute then
    begin
      SaveFile := FileName;

      GetDir(0,dirinfo);
      SetCurrentDir(dirinfo);

      AssignFile(txt,dirinfo0+'\dirinfo');
      Rewrite(txt);
      writeln(txt,dirinfo);
      CloseFile(txt);

      AssignFile(txt,SaveFile);
      Rewrite(txt);

      writeln(txt,'No. of molecules used in simulation = '+IntToSTr(Form1.SpinEdit1.Value));
      writeln(txt,'No. of branches at the molecule =  '+IntToSTr(Form1.SpinEdit3.Value));
      writeln(txt,'No. of viologen units per each branch = '+IntToSTr(Form1.SpinEdit2.Value));
      writeln(txt,'The net number of reduced site per molecule = '+Form1.Edit3.Text);
      writeln(txt,'The sampling number of Monte Carlo Simulation = '+IntToSTr(Form1.SpinEdit4.Value));
      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'');

      for jj := 0 to Form3.StringGrid1.RowCount-1 do
        begin
          for ii := 0 to Form3.StringGrid1.ColCount-2 do
            begin
              write(txt,Form3.StringGrid1.Cells[ii,jj],'	');
            end;
           writeln(txt,Form3.StringGrid1.Cells[Form3.StringGrid2.ColCount-1,jj]);
        end;

      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'');

      for jj := 0 to Form3.StringGrid2.RowCount-1 do
        begin
          for ii := 0 to Form3.StringGrid2.ColCount-2 do
            begin
              write(txt,Form3.StringGrid2.Cells[ii,jj],'	');
            end;
           writeln(txt,Form3.StringGrid2.Cells[Form3.StringGrid2.ColCount-1,jj]);
        end;
      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'');

      CloseFile(txt);
    end;
end;

end.
